// MyListBox.cpp : implementation file
//

#include "stdafx.h"
#include "ColorListBox.h"
#include "MyListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyListBox

CMyListBox::CMyListBox()
{
}

CMyListBox::~CMyListBox()
{
}


BEGIN_MESSAGE_MAP(CMyListBox, CListBox)
	//{{AFX_MSG_MAP(CMyListBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

void CMyListBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	ASSERT(lpDrawItemStruct->CtlType == ODT_LISTBOX);
	LPCTSTR lpszText = (LPCTSTR) lpDrawItemStruct->itemData;
	ASSERT(lpszText != NULL);
	CDC dc;
    

	dc.Attach(lpDrawItemStruct->hDC);
	CRect rect;
	rect=lpDrawItemStruct->rcItem;

	BOOL bLostFocus=(GetFocus()!=this);

	if(lpDrawItemStruct->itemState & ODS_SELECTED)
	{
		if (bLostFocus)
		{
			CBrush br(RGB(192,192,192));
			dc.FillRect(&rect,&br);
		}
		else 
		{
			CBrush br(RGB(0,255,0));
            dc.FillRect(&rect,&br);
		}
		//dc.SetTextColor(RGB(0,0,255));
	}
    else
	{
		CBrush br(RGB(255,255,255));
		dc.FillRect(&rect,&br);
	    //dc.SetTextColor(RGB(255,0,0));
	}

	dc.DrawText(lpszText,rect,DT_LEFT|DT_WORDBREAK);
/*
	//   ,      .
	COLORREF crOldTextColor = dc.GetTextColor();
	COLORREF crOldBkColor = dc.GetBkColor();

	//    ,    
	//   ,   . , 
	// Rect,      .

	if ((lpDrawItemStruct->itemAction | ODA_SELECT) &&
		(lpDrawItemStruct->itemState & ODS_SELECTED))
	{
		dc.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		dc.SetBkColor(::GetSysColor(COLOR_HIGHLIGHT));
		dc.FillSolidRect(&lpDrawItemStruct->rcItem, 
			::GetSysColor(COLOR_HIGHLIGHT));
	}
	else
		dc.FillSolidRect(&lpDrawItemStruct->rcItem, crOldBkColor);

	//     ,    
	// Rect .
	if ((lpDrawItemStruct->itemAction | ODA_FOCUS) &&
		(lpDrawItemStruct->itemState & ODS_FOCUS))
	{
		CBrush br(RGB(255, 0, 0));
		dc.FrameRect(&lpDrawItemStruct->rcItem, &br);
	}

	//  
	dc.DrawText(lpszText,strlen(lpszText),&lpDrawItemStruct->rcItem,
		        DT_CENTER|DT_SINGLELINE|DT_VCENTER);

	//         
	//  .

	dc.SetTextColor(crOldTextColor);
	dc.SetBkColor(crOldBkColor);
*/
	dc.Detach();
}

// CMyListBox -    ,   CListBox.  
//    ,  strcmp      
//  .      
//  :
//   pmyListBox->Create(
//      WS_CHILD|WS_VISIBLE|WS_BORDER|WS_HSCROLL|WS_VSCROLL|
//      LBS_SORT|LBS_MULTIPLESEL|LBS_OWNERDRAWVARIABLE,
//      myRect, pParentWnd, 1);
//
int CMyListBox::CompareItem(LPCOMPAREITEMSTRUCT lpCompareItemStruct) 
{
	ASSERT(lpCompareItemStruct->CtlType == ODT_LISTBOX);
	LPCTSTR lpszText1 = (LPCTSTR) lpCompareItemStruct->itemData1;
	ASSERT(lpszText1 != NULL);
	LPCTSTR lpszText2 = (LPCTSTR) lpCompareItemStruct->itemData2;
	ASSERT(lpszText2 != NULL);

	return strcmp(lpszText2, lpszText1);
}

// CMyListBox message handlers
// CMyListBox -    ,   CListBox.  
//          
//   .      
//  :
//   pmyListBox->Create(
//      WS_CHILD|WS_VISIBLE|WS_BORDER|WS_HSCROLL|WS_VSCROLL|
//      LBS_SORT|LBS_MULTIPLESEL|LBS_OWNERDRAWVARIABLE,
//      myRect, pParentWnd, 1);
//
void CMyListBox::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	ASSERT(lpMeasureItemStruct->CtlType == ODT_LISTBOX);
	LPCTSTR lpszText = (LPCTSTR) lpMeasureItemStruct->itemData;
	ASSERT(lpszText != NULL);
	CSize sz;
	CDC* pDC = GetDC();

	sz = pDC->GetTextExtent(lpszText);

	ReleaseDC(pDC);

	lpMeasureItemStruct->itemHeight = 2*sz.cy;
}





